# -*- coding: utf-8 -*-
from setuphelpers import *
import bs4 as BeautifulSoup


def update_package():
    # Initializing variables
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    url = "https://www.oracle.com/java/technologies/javase-jre8-downloads.html"
    bin_name_string_x86 = "jre-8u%s-windows-i586.exe"
    bin_name_string_x64 = "jre-8u%s-windows-x64.exe"
    # Download Guide: https://gist.github.com/wavezhang/ba8425f24a968ec9b2a8619d7c2d86a6
    # https://gist.github.com/wavezhang/ba8425f24a968ec9b2a8619d7c2d86a6#gistcomment-3377085

    # Getting latest version from official website
    # bs_search = bs_find_all('https://www.java.com/en/download/manual.jsp', 'a', 'title',  'Download Java software for Windows Offline')
    bs_search = bs_find_all(url, "a", "href", "/downloads/javase-software-license-agreement.html#license-lightbox", proxies=proxies)
    for bs_seak in bs_search:
        if bs_seak["data-file"].endswith("-windows-i586.exe"):
            update_number = bs_seak["data-file"].split("/")[-3].split("-")[-0].replace("8u", "")
            build_number = bs_seak["data-file"].split("/")[-3].split("-")[-1].replace("b", "")
            encrypted_path = bs_seak["data-file"].split("/")[-2]
            break

    arch_name_x86 = "windows-i586"
    arch_name_x64 = "windows-x64"

    latest_bin_x86 = bin_name_string_x86 % update_number
    latest_bin_x64 = bin_name_string_x64 % update_number

    file_name_x86 = "jre-8u%s-%s.exe" % (update_number, arch_name_x86)
    file_name_x64 = "jre-8u%s-%s.exe" % (update_number, arch_name_x64)

    # https://sdlc-esd.oracle.com/ESD6/JSCDL/jdk/8u271-b09/61ae65e088624f5aaa0b1d2d801acb16/jre-8u271-windows-i586.exe?GroupName=JSC&FilePath=/ESD6/JSCDL/jdk/8u271-b09/61ae65e088624f5aaa0b1d2d801acb16/jre-8u271-windows-i586.exe&BHost=javadl.sun.com&File=jre-8u271-windows-i586.exe&=1603380937_844fab0e9ecd6dcdf4efe8d98d697ce4&ext=.exe
    # https://javadl.oracle.com/webapps/download/AutoDL?BundleId=243735_61ae65e088624f5aaa0b1d2d801acb16 # jre-8u271-windows-i586.exe
    # https://javadl.oracle.com/webapps/download/GetFile/1.8.0_271-b09/61ae65e088624f5aaa0b1d2d801acb16/windows-i586/jdk-8u271-windows-x64.exe
    # https://javadl.oracle.com/webapps/download/GetFile/1.8.0_[xxx]-b[xx]/[encrypted_path]/windows-i586/[file_name_exe]

    url_dl_x86 = "https://javadl.oracle.com/webapps/download/GetFile/1.8.0_%s-b%s/%s/%s/%s" % (
        update_number,
        build_number,
        encrypted_path,
        arch_name_x86,
        latest_bin_x86,
    )
    url_dl_x64 = "https://javadl.oracle.com/webapps/download/GetFile/1.8.0_%s-b%s/%s/%s/%s" % (
        update_number,
        build_number,
        encrypted_path,
        arch_name_x86,
        latest_bin_x64,
    )

    version = "8.0.%s" % update_number

    print("Latest %s version is: Update %s" % (app_name, update_number))

    # Downloading latest binaries
    if not isfile(latest_bin_x64):
        print("Downloading " + latest_bin_x64)
        if not isfile(latest_bin_x64):
            wget(url_dl_x64, latest_bin_x64, proxies=proxies)

    if not isfile(latest_bin_x86):
        print("Downloading " + latest_bin_x86)
        if not isfile(latest_bin_x86):
            wget(url_dl_x86, latest_bin_x86, proxies=proxies)

        # Changing version of the package
        control.version = "%s-%s" % (version, int(control.version.split("-")[-1]) + 1)
        control.save_control_to_wapt()
        print("Changing package version to: %s in WAPT\\control" % control.version)

    # Deleting outdated binaries
    remove_outdated_binaries(update_number)
